%define ver      0.1.2
%define rel      1
%define prefix   /usr

Summary: POP3 switch to direct users to a real pop server
Name: perdition
Version: %ver
Release: %rel
Copyright: GPL
Group: Networking/Daemons
Source: ftp://ftp.vergenet.net/pub/perdition/perdition-%{ver}.tar.gz
BuildRoot: /var/tmp/perdition-%{PACKAGE_VERSION}-root
Packager: Horms <horms@vergenet.net>
URL: http://vergenet.net/linux/perdition/
Docdir: %{prefix}/doc

%description
Perdition is allows users to connect to a content-free pop
server that will redirect them to their real pop server.
This enables pop for a domain to be split accross multiple
real pop servers on a per user basis. This can also be used
to as a POP proxy expecially in firewall applications.


%prep
%setup

%build
CFLAGS="${RPM_OPT_FLAGS}" ./configure --prefix=%prefix
make

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p ${RPM_BUILD_ROOT}/{,etc/{,rc.d/init.d,perdition,pam.d},@prefix/sbin}

make prefix=$RPM_BUILD_ROOT%{prefix} install

install -m744 ${RPM_BUILD_DIR}/perdition-%{ver}/etc/rc.d/init.d/perdition \
  ${RPM_BUILD_ROOT}/etc/rc.d/init.d/perdition
install -m744 ${RPM_BUILD_DIR}/perdition-%{ver}/etc/pam.d/perdition \
  ${RPM_BUILD_ROOT}/etc/pam.d/perdition
  
install -m600 ${RPM_BUILD_DIR}/perdition-%{ver}/etc/perdition/popmap \
  ${RPM_BUILD_ROOT}/etc/perdition/popmap
install -m600 ${RPM_BUILD_DIR}/perdition-%{ver}/etc/perdition/Makefile \
  ${RPM_BUILD_ROOT}/etc/perdition/Makefile
pushd ${RPM_BUILD_ROOT}/etc/perdition/
BINDIR=%prefix/bin make -f Makefile > ${RPM_BUILD_ROOT}/etc/perdition/makefile
popd

cd ${RPM_BUILD_ROOT}/usr/sbin
ln -s perdition perdition.0
ln -s perdition perdition.1

%clean
rm -rf $RPM_BUILD_DIR/perdition-%{ver}
rm -rf $RPM_BUILD_ROOT

%post
make -C /etc/perdition/
/sbin/chkconfig --add perdition

%postun

%preun
/sbin/chkconfig --del perdition

%files
%defattr(-,root,root)
%doc README AUTHORS ChangeLog NEWS CODING_LOCATIONS TODO
%attr(755,root,root) %{prefix}/bin/makegdbm
%attr(755,root,root) %{prefix}/sbin/perdition
%attr(755,root,root) %{prefix}/sbin/perdition.0
%attr(755,root,root) %{prefix}/sbin/perdition.1
/etc/pam.d/perdition
/etc/rc.d/init.d/perdition
/etc/perdition/makefile
%config /etc/perdition/popmap

%changelog
* Sat Sep 18 1999 Horms <horms@vergenet.net>
- updated for 0.1.0

* Sat May 29 1999 Horms <horms@vergenet.net>
- inital release

