/**********************************************************************
 * imap4.c                                               September 1999
 * Horms                                             horms@vergenet.net
 *
 * IMAP4 protocol defines
 *
 * Licenced under the terms of the GNU GPL
 *
 **********************************************************************/

#include "imap4.h"

/**********************************************************************
 * imap4_intitialise_proto
 * Intialialoise the protocol structure for the imap4 protocol
 * Pre: protocol: pointer to an allocated protocol structure
 * Post: Return seeded protocol stricture
 *              NULL on error
 **********************************************************************/

char *imap4_type[]={IMAP4_OK, IMAP4_NO, IMAP4_BAD};

protocol_t *imap4_initialise_protocol(protocol_t *protocol){
  extern char *imap4_type[];

  protocol->type = imap4_type;
  protocol->write = (
    int (*)(const int, const token_t *, const char *, const char *)
  ) imap4_write;
  protocol->greeting_string = IMAP4_GREETING;
  protocol->quit_string = IMAP4_QUIT;
  protocol->one_time_tag = IMAP4_ONE_TIME_TAG;
  protocol->in_get_pw= (
    struct passwd *(*)(const int, const int, token_t **)
  ) imap4_in_get_pw;
  protocol->out_authenticate= (
    int (*)(
      const int,
      const int,
      const struct passwd *,
      protocol_t *
    )
  ) imap4_out_authenticate;
  protocol->in_authenticate= (
    int (*)(
      const struct passwd *pw,
      const int err_fd,
      const token_t *tag
    )
  ) imap4_in_authenticate;
  protocol->out_response= (
    int (*)(
      const int,
      const char *,
      const token_t *,
      queue **
    )
  ) imap4_out_response;
  protocol->destroy = (void (*)(protocol_t *)) imap4_destroy_protocol;
  protocol->port = (char *(*)(const char *)) imap4_port;

  return(protocol);
}


/**********************************************************************
 * imap4_destroy_proto 
 * Destory protocol specifig elements of the protocol struture
 **********************************************************************/

void imap4_destroy_protocol(protocol_t *protocol){
  ;
}


/**********************************************************************
 * imap4_port 
 * Return the port to be used
 * pre: port: port that has been set
 * post: IMAP4_DEFAULT_PORT if port is PERDITION_PORT_PROTOCOL_DEPENDANT
 *       port otherwise
 **********************************************************************/

char *imap4_port(char *port){
  if(!strcmp(PERDITION_PORT_PROTOCOL_DEPENDANT, port)){
    return(IMAP4_DEFAULT_PORT);
  }

  return(port);
}

