/**********************************************************************
 * imap4_out.h                                           September 1999
 * Horms                                             horms@vergenet.net
 *
 * Functions to communicate with upstream IMAP4 server
 *
 * Released under the terms of the GNU GPL
 *
 **********************************************************************/

#ifndef IMAP4_OUT_BLUM
#define IMAP4_OUT_BLUM

#include <pwd.h>
#include <sys/types.h>

#include "queue.h"
#include "token.h"
#include "imap4_write.h"
#include "perdition_types.h"
#include "str.h"
#include "greeting.h"
#include "queue_func.h"
#include "protocol_t.h"

int imap4_out_authenticate(
  const int in_fd, 
  const int out_fd, 
  const struct passwd *pw,
  protocol_t *protocol
);
int imap4_out_response(
  const int in_fd, 
  const char *tag_string,
  const token_t *desired_token,
  queue **q
);

#endif
