/**********************************************************************
 * pop3_write.c                                          September 1999
 * Horms                                             horms@vergenet.net
 *
 * Write POP3 protocol commands and responses
 *
 * Licenced under the terms of the GNU GPL
 *
 **********************************************************************/

#include "pop3_write.h"

/**********************************************************************
 * pop3_write
 * Send an error to the user
 * Pre: fd: file descriptor to write to
 *      tag: ignored
 *      type: type of message, POP3_OK or POP3_ERR
 *      string: mesage to display
 * Return 1 on success
 *        0 otherwise
 **********************************************************************/
      
int pop3_write(
  const int fd, 
  const token_t *tag,
  const char *type, 
  const char *string
){
  if(write_str(fd, 3, type, " ", string)<0){
    syslog(LOG_WARNING, "pop3_write: write_strings");
    return(-1);
  }   
  return(0);
}   
