/**********************************************************************
 * token.h                                               September 1999
 * Horms                                             horms@vergenet.net
 *
 * Token to encapsulate a byte string
 *
 * Licenced under the GNU GPL
 *
 **********************************************************************/

#ifndef TOKEN_BLUM
#define TOKEN_BLUM

#include <sys/time.h>
#include <sys/types.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <ctype.h>

#include "log.h"
#include "str.h"
#include "perdition_types.h"
#include "daemon.h"

#define BUFFER_SIZE 1024

#define DESTROY_TOKEN (void (*)(const void *))destroy_token
  
typedef struct{
  ssize_t n;
  unsigned char * buf;
  int eol;
}token_t;

token_t *create_token(token_t *t);

void assign_token(
  token_t *t, 
  unsigned char * buf, 
  const ssize_t n, 
  const int eol
);

void unassign_token(token_t *t);

void destroy_token(token_t **t);

int write_token(const int fd, const token_t *t);

token_t *read_token(const int fd, token_t *t);

int token_is_eol(const token_t *t);

int token_cmp(const token_t *a, const token_t *b);

int token_is_null(const token_t *t);

char *token_to_string(const token_t *t, char *string);

#endif
